#include "BaseApp.h"

BaseApp::BaseApp()
{
		m_bInitted = false;
		m_bConsoleVisible = false;
		SetFPSVisible(false);
}

BaseApp::~BaseApp()
{
	Kill();
}

void BaseApp::Kill()
{
	
}

bool BaseApp::Init()
{

	if (m_bInitted)	
	{
		LogMsg("Why are we initting more than once?");
		return true;
	}

	m_bInitted = true;

	glMatrixMode(GL_MODELVIEW);
	glDepthMask(GL_TRUE);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_ALPHA_TEST);
	glDisable( GL_BLEND );
	glAlphaFunc(GL_GREATER, 0.9f);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);	
	glEnableClientState(GL_NORMAL_ARRAY);	

	return true;
}

void DrawConsole()
{

}

void BaseApp::Draw()
{

	if (GetFPSVisible())
	{
		char stTemp[256];
		sprintf(stTemp, "FPS: %d - Mem: %.2f MB", m_gameTimer.GetFPS(), float(GetFreeMemory()/1024)/ 1024);
	}

	//draw the console messages?
	if (GetConsoleVisible())
	{
		DrawConsole();
	}

	ResetOrthoFlag();
}

void BaseApp::Update()
{
	m_gameTimer.Update();
	if (GetMessageManager()) GetMessageManager()->Update();
}


void BaseApp::OnScreenSizeChange()
{
	LogMsg("Changing screen-size to %d, %d, %d", GetScreenSizeX(), GetScreenSizeY(), GetOrientation());
}

void BaseApp::SetConsoleVisible( bool bNew )
{
	m_bConsoleVisible = bNew;
}


void BaseApp::OnMessage(Message &m)
{
}