//  ***************************************************************
//  BaseApp - Creation date:  03/06/2009
//  -------------------------------------------------------------
//  Robinson Technologies - Check license.txt for license info.
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef BaseApp_h__
#define BaseApp_h__

#include "GameTimer.h"
#include "Console.h"

//these aren't really used by this class but makes it easy for me to share these with everyone by only including this header
#include "util/MiscUtils.h"
#include "util/RenderUtils.h"
#include "MessageManager.h"

class BaseApp
{
public:
	BaseApp();
	virtual ~BaseApp();

	virtual bool Init();
	virtual void Kill();
	virtual void Draw();
	virtual void Update();
	virtual void OnScreenSizeChange();
	void SetConsoleVisible(bool bNew);
	bool GetConsoleVisible() {return m_bConsoleVisible;}
	bool GetFPSVisible() {return m_bFPSVisible;}
	void SetFPSVisible(bool bNew) {m_bFPSVisible = bNew;}
	unsigned int GetGameTick() {return m_gameTimer.GetGameTick();}
	void SetGameTick(unsigned int tick) {m_gameTimer.SetGameTick(tick);}
	unsigned int GetTick() {return m_gameTimer.GetTick();}
	float GetDelta() {return m_gameTimer.GetDelta();}
	Console * GetConsole() {return &m_console;}
	void SetGameTickPause(bool bNew) {m_gameTimer.SetGameTickPause(bNew);}
	virtual void OnMessage(Message &m);
protected:
	
	bool m_bConsoleVisible;
	bool m_bFPSVisible;
	bool m_bInitted;
	GameTimer m_gameTimer;
	Console m_console;
	
};

BaseApp * GetBaseApp(); //supply this yourself...
MessageManager * GetMessageManager(); //supply this yourself

#endif // BaseApp_h__