//  ***************************************************************
//  GameTimer - Creation date:  03/06/2009
//  -------------------------------------------------------------
//  Robinson Technologies - Check license.txt for license info.
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef GameTimer_h__
#define GameTimer_h__

#include "PlatformSetup.h"

class GameTimer
{
public:
	
	void Update();

	unsigned int GetTick() {return m_timeMS;}
	unsigned int GetGameTick() {return m_gameTimer;} //this timer can be paused with SetGameTimerPause(), use for all entity/object timing in the game
	void SetGameTick(unsigned int tick) {m_gameTimer = tick;}
	int GetFPS() {return m_fps;}
	GameTimer();
	virtual ~GameTimer();
	float GetDelta() {return m_deltaFloat;}
	void SetGameTickPause(bool bNew) {m_bGameTimerPaused = bNew;}
	void Reset();

private:
	
	unsigned int m_lastTimeMS;
	unsigned int m_timeMS;
	unsigned int m_fpsTimer;
	unsigned int m_gameTimer;
	int m_fps;
	int m_fpsTemp;
	bool m_bGameTimerPaused;
	int m_deltaMS;
	float m_deltaFloat;

};

#endif // GameTimer_h__