#pragma once

#ifdef WIN32
#include "PlatformSetupWin.h"
#else
#include "PlatformSetupOSX.h"
#endif

#ifdef __cplusplus
	#include <cstdio>
	#include <string>
	#include <vector>
	#include <cmath>
	#include <cassert>
	#include <list>
	#include <map>
	#include <stdlib.h>
	#include <iostream>
	#include <sstream>
	
	using namespace std;
#endif

#ifndef SAFE_DELETE
#define SAFE_DELETE(p)      { if(p) { delete (p); (p)=NULL; } }
#endif

#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }

#ifndef SAFE_FREE
#define SAFE_FREE(p)      { if(p) { free (p); (p)=NULL; } }
#endif

//this must exist somewhere, used for log messages	
void LogMsg ( const char* traceStr, ... );
