#include "MiscUtils.h"

//taken from Gamedeveloper magazine's InnerProduct (Sean Barrett 2005-03-15)

// circular shift hash -- produces good results if modding by a prime;
// longword at a time would be faster (need alpha-style "is any byte 0"),
// or just use the first longword

unsigned int HashString(const char *str)
{

	if (!str) return 0;

	unsigned char *n = (unsigned char *) str;
	unsigned int acc = 0x55555555;
	while (*n)
		acc = (acc >> 27) + (acc << 5) + *n++;
	return acc;
}

bool IsEven(int number)
{
	return (number & 1) == 0;
}


string ToLowerCaseString (const string & s)
{
	string d (s);
	for (unsigned int i=0; i < d.length(); i++)
	{
		d[i] = tolower(d[i]);
	}

	return d;
}  // end of tolower

void SetIntWithTarget(int32 *p_out_dest, int r_target, int r_amount)
{
	if (*p_out_dest > r_target)
	{
		//make it less
		*p_out_dest -= r_amount;
		if (*p_out_dest < r_target) *p_out_dest = r_target;

	}   else
	{
		//make it more
		*p_out_dest += r_amount;
		if (*p_out_dest > r_target) *p_out_dest = r_target;
	}

}

int mod(int a, int b)
{

	assert(b != 0 && "You can't use 0 in this."); 
	int const rem = a % b;
	if ( (-1 % 2 == 1) || rem >= 0)
		return rem; else
		return rem + abs(b);
}

unsigned int Random(unsigned int ui_max)
{
	return rand() % ui_max;
}

unsigned int RandomRange(unsigned int ui_min, unsigned int ui_max)
{
	return Random(ui_max-ui_min)+ui_min;
}

float LerpFloat(float f_origin, float f_target, float f_percent)
{
	return (f_origin - ((f_origin-f_target)*f_percent));
}

