/*
 *  RenderUtils.h
 *  
 *
 *  Created by Seth Robinson on 3/18/09.
 *  Copyright 2009 Robinson Technologies. All rights reserved.
 *
 */

#ifndef RenderUtils_h__
#define RenderUtils_h__

#include "PlatformSetup.h"

#ifndef _DEBUG
#define CHECK_GL_ERROR() 
#else
#define CHECK_GL_ERROR() { GLenum __error = pGL->glGetError(); if(__error) BREWLog(("OpenGL error 0x%04X in %s\n", __error, __FUNCTION__));}
#endif

enum eOrientationMode
{
	//these match the iphone versions
	ORIENTATION_PORTRAIT = 1,
	ORIENTATION_LANDSCAPE = 3
};

#define MAKE_RGB(r, g, b)      ( ((uint32)(r) << 8) + ((uint32)(g) << 16) + ((uint32)(b) << 24) )
#define MAKE_RGBA(r, g, b, a) ( ((uint32)(r) << 8) + ((uint32)(g) << 16) + ((uint32)(b) << 24) + ((uint32)(a)))

void RenderGLTriangle();

int GetScreenSizeY();
int GetScreenSizeX();

void SetupScreenInfo(int x, int y, int orientation);
void orthographic();
void ConvertCoordinatesIfRequired(int &xPos, int &yPos);
void ConvertCoordinatesIfRequired(float &xPos, float &yPos);
bool NeedsOrthoSet();
void ResetOrthoFlag();
void SetOrthoMode();

bool InLandscapeGUIMode(); //use this for things solely about screen size, so windows fake landscape modes can test GUI things
int GetOrientation(); //if three, iPhone is in landscape mode and things will be rotated
#endif // RenderUtils_h__
